<script lang="ts">
import Vue from 'vue';
import VideoModal from '~/components/solutions/video-modal.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'DibPillar2',
  components: {
    VideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data: () => ({
    showModal: false,
  }),
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <SlpContainer>
    <article>
      <SlpTypography variant="heading1-bold" tag="h2" class="slp-mb-16">
        {{ data.header }}
      </SlpTypography>
      <SlpTypography variant="heading5" tag="div" class="slp-mb-64">
        <div v-html="$md.render(data.text)" />
      </SlpTypography>
      <div class="images slp-my-24">
        <div class="stacked">
          <img :src="data.images[0].src" :alt="data.images[0].alt" />
          <img :src="data.images[1].src" :alt="data.images[1].alt" />
        </div>
        <div class="stacked">
          <img :src="data.images[2].src" :alt="data.images[2].alt" />
          <div
            v-if="data.video"
            class="video-wrapper img-col"
            @click="openModal()"
          >
            <SlpIcon
              class="play-icon"
              name="play-circle"
              variant="marketing"
              size="lg"
            />
            <img
              id="video-container__image"
              preload
              class="thumbnail-image"
              :src="data.video.thumbnail"
              alt=""
            />
          </div>

          <VideoModal
            v-if="data.video"
            v-show="showModal && data.video"
            light-background
            :visible="showModal"
            @close="showModal = false"
          >
            <template #body>
              <lite-vimeo
                :videoid="getVimeoVideoId(createVideoSource(data.video.url))"
                :videotitle="getVimeoVideoId(createVideoSource(data.video.url))"
                autoplay
              ></lite-vimeo>
            </template>
          </VideoModal>
        </div>
      </div>
    </article>

    <article>
      <div class="content-block">
        <SlpTypography variant="heading2-bold" tag="h3" class="slp-mb-16">
          {{ data.events.subtitle }}
        </SlpTypography>
        <SlpTypography variant="heading5" tag="div" class="slp-mb-64">
          <div v-html="$md.render(data.events.text)" />
        </SlpTypography>
      </div>
    </article>
    <article>
      <div class="content-block">
        <SlpTypography variant="heading2-bold" tag="h3" class="slp-mb-16">
          {{ data.do_good.subtitle }}
        </SlpTypography>
        <SlpTypography variant="heading5" tag="div" class="slp-mb-64">
          <div v-html="$md.render(data.do_good.text)" />
        </SlpTypography>
      </div>

      <SlpRow class="cards">
        <SlpColumn
          v-for="card in data.do_good.cards"
          :key="card.title"
          :cols="4"
          class="card-container"
        >
          <div
            :href="card.cta.href"
            :data-ga-name="card.cta.data_ga_name"
            :data-ga-location="card.cta.data_ga_location"
            class="card"
          >
            <SlpTypography variant="heading5-bold" tag="h3" class="slp-mb-24">
              {{ card.title }}
            </SlpTypography>
            <SlpTypography variant="body1" tag="div" class="slp-mb-24">
              <div class="card__text" v-html="$md.render(card.text)" />
            </SlpTypography>

            <a
              class="card-cta"
              :href="card.cta.href"
              :data-ga-name="card.cta.data_ga_name"
              :data-ga-location="card.cta.data_ga_location"
            >
              <span>{{ card.cta.text }}</span>
              <SlpIcon
                class="learn-more-icon"
                name="chevron-lg-right"
                variant="product"
              />
            </a>
          </div>
        </SlpColumn>
      </SlpRow>
      <SlpRow class="cards">
        <SlpColumn
          v-for="stat in data.do_good.stats"
          :key="stat.number"
          :cols="4"
          class="card-container"
        >
          <SlpTypography
            variant="heading1-bold"
            tag="p"
            class="gradient-number"
          >
            {{ stat.number }}
          </SlpTypography>

          <div>
            <SlpTypography
              variant="heading4-bold"
              tag="div"
              class="gradient-number-label slp-mb-16"
            >
              {{ stat.label }}
            </SlpTypography>
            <SlpTypography
              variant="body2"
              tag="div"
              class="gradient-number-text"
            >
              {{ stat.text }}
            </SlpTypography>
          </div>
        </SlpColumn>
      </SlpRow>
      <SlpRow class="slp-mt-48">
        <div class="content-block">
          <SlpTypography variant="heading2-bold" tag="h3" class="slp-mb-16">
            {{ data.gitlab_foundation.subtitle }}
          </SlpTypography>
          <SlpTypography variant="heading5" tag="div" class="slp-mb-48">
            <div v-html="$md.render(data.gitlab_foundation.text)" />
          </SlpTypography>
        </div>
        <div class="quote-container slp-mt-8">
          <div class="quote">
            <div class="quote-icon">
              <SlpIcon
                name="quote"
                variant="marketing"
                size="md"
                class="quote-icon"
              />
            </div>

            <SlpTypography
              variant="quotes"
              tag="p"
              class="quote-text slp-mt-24"
            >
              {{ data.gitlab_foundation.quote }}
            </SlpTypography>
            <div class="slp-mt-16 quote-author">
              <div>
                <img
                  v-if="data.gitlab_foundation.img_src"
                  :src="data.gitlab_foundation.img_src"
                  alt=""
                />
              </div>
              <div>
                <SlpTypography variant="body2-bold" tag="p">
                  {{ data.gitlab_foundation.name }}
                </SlpTypography>
                <SlpTypography variant="body2" tag="p">
                  {{ data.gitlab_foundation.title }}
                </SlpTypography>
              </div>
            </div>
            <div v-if="data.gitlab_foundation.cta" class="slp-mt-24">
              <SlpButton
                variant="tertiary"
                :href="data.gitlab_foundation.cta.href"
                :data-ga-name="data.gitlab_foundation.cta.data_ga_name"
                :data-ga-location="data.gitlab_foundation.cta.data_ga_location"
              >
                {{ data.gitlab_foundation.cta.text }}
                <SlpIcon name="chevron-lg-right" variant="product" />
              </SlpButton>
            </div>
          </div>
        </div>
      </SlpRow>
    </article>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.content-block {
  max-width: 65%;
  margin: 32px 0 0 0;

  &:deep {
    a {
      text-decoration: underline;
      color: $color-text-300;

      &:hover {
        color: $color-text-link-100;
      }
    }
  }

  @media (max-width: $breakpoint-md) {
    max-width: 100%;
  }
}
.images {
  display: flex;
  align-items: stretch;
  position: relative;
  flex-wrap: nowrap;

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
  }

  img {
    display: block;

    @media (max-width: $breakpoint-md) {
      width: 100%;
      margin-bottom: 16px;
    }
  }

  .stacked {
    width: 100%;
    margin-right: 32px;
    display: flex;
    justify-content: space-between;
    flex-direction: column;

    @media (max-width: $breakpoint-md) {
      margin-right: 0;
    }

    .img-col {
      display: flex;
      justify-content: right;
      position: relative;

      @media (max-width: $breakpoint-lg) {
        flex: 0 1 100%;
      }
    }

    img {
      border-radius: 8px;
      max-height: 275px;
      margin-bottom: 32px;
    }
    .video-wrapper {
      cursor: pointer;
      position: relative;
      flex: 1 1 100%;
      max-height: 456px;
      max-width: 594px;
      border-radius: 8px 8px 160px 8px;
      display: flex;
      align-items: center;

      @media (max-width: $breakpoint-md) {
        width: 100%;
        max-width: 100%;
        border-radius: 4px 4px 40px 4px;
      }

      .play-icon {
        color: $color-text-link-100;
        cursor: pointer;
        font-size: 48px;
        left: 50%;
        position: absolute;
        top: 50%;
        transform: translate(-50%, -50%);
        z-index: 2;
      }

      img {
        object-fit: cover;
        width: 100%;
        display: block;
        border-radius: 8px 8px 160px 8px;
        border: 1px solid $color-surface-300;
        @media (max-width: $breakpoint-md) {
          border-radius: 4px 4px 40px 4px;
        }
      }
    }
  }

  .cropped {
    width: 100%;
  }

  .cropped img {
    width: 100%;
    border-radius: 8px 8px 100px 8px;
  }
}
.cards {
  margin-top: 32px;
  margin-bottom: 16px;
  align-items: stretch;

  .card-container {
    padding: 16px;
    display: flex;
    flex-direction: column;
    flex-grow: 1;

    @media (max-width: breakpoint-md) {
      padding: 0;
    }
  }

  .card {
    border-radius: 8px;
    background: #f6f3fe;
    padding: 32px 24px;
    display: flex;
    flex-direction: column;
    flex-grow: 1;
    color: $color-text-300;
    transition: all 0.2s ease-in-out;

    .slp-icon {
      transition: all 0.2s ease-in-out;
    }

    &:hover {
      border-radius: 8px 8px 100px 8px;

      .slp-icon {
        transform: translateX(8px);
      }

      .card-cta {
        text-decoration-color: $color-text-300;

        transition: all 0.2s ease-in-out;
      }
    }

    &__text {
      color: $color-text-200;

      &:deep ul {
        list-style: disc;
        padding-left: 1.5em;
      }

      &:deep a {
        color: $color-text-300;
        text-decoration: underline;

        &:hover {
          color: $color-text-link-100;
        }
      }
    }
  }

  .card-cta {
    box-sizing: border-box;
    font-family: 'GitLab Sans' 'sans-serif';
    min-width: 68px;
    display: inline-flex;
    align-items: center;
    text-align: center;
    vertical-align: middle;
    padding: 11px 16px;
    -webkit-text-decoration: none;
    text-decoration: underline;
    text-underline-offset: 4px;
    text-decoration-color: transparent;
    border-radius: 4px;
    font-weight: 600;
    font-size: 18px;
    line-height: 20px;
    color: #171321;
    border: none;
    padding-left: 0;
    transition: all 0.2s ease-in-out;
    margin-top: auto;
  }

  .cta-link {
    display: flex;
    align-items: center;
    text-decoration: none;
    color: inherit;
  }
}

.gradient-number {
  font-size: 100px;
  line-height: 121px;
  font-weight: 800;
  -webkit-text-fill-color: transparent;
  background: linear-gradient(
    93.78deg,
    rgba(227, 153, 93, 0.7) 8.53%,
    rgba(203, 146, 150, 0.7) 14.9%,
    rgba(127, 72, 214, 0.7) 95.91%
  );

  background-clip: text;
  -webkit-background-clip: text;

  &-text {
    color: $color-text-200;
  }
}

.quote-container {
  @media (min-width: $breakpoint-md) {
    padding: 0 64px;
  }

  .quote-icon {
    margin-bottom: 24px;
  }

  .quote-author {
    margin-top: 32px;
    display: flex;
    gap: 32px;
    flex-direction: row;
    flex-wrap: nowrap;
    align-items: center;
    img {
      max-width: 120px;
      height: auto;
      border-radius: 4px 4px 64px 4px;
    }
  }

  .quote-text {
    display: block;
    margin-bottom: 24px;
  }

  .quote {
    display: flex;
    flex-direction: column;
    padding: 48px;
    border: 1px solid;
    border-radius: 8px 8px 100px 8px;
    background: #ffffff;
    background-clip: padding-box;
    border: 1px solid transparent;
    position: relative;
    box-sizing: border-box;

    @media (max-width: $breakpoint-md) {
      padding: 48px 24px;
    }

    &:before {
      content: '';
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      z-index: -1;
      margin: -1px;
      border-radius: inherit;
      background: linear-gradient(
        93.78deg,
        rgba(227, 153, 93, 0.5) 8.53%,
        rgba(203, 146, 150, 0.5) 14.9%,
        rgba(127, 72, 214, 0.5) 95.91%
      );
    }
  }
}
</style>
